Description

The documentation describes the properties and serialization of DataONE exceptions:

http://mule1.dataone.org/ArchitectureDocs-current/apis/Exceptions.html

However, the definition in the schema:

https://repository.dataone.org/software/cicore/tags/D1_SCHEMA_1_1_1/dataoneErrors.xsd

differs, and so presents an inconsistent reference for implementations.

The Java code appears to follow the documentation, however the python implementation uses the schema to generate exception

messages, and so follows the schema definition.

The schema and python code need to be updated to reflect the description in the documentation. Also, all implementations of MN

and client software need to be informed of the issue and how they may be impacted.

Subtasks:

Task # 4189: Update dataoneErrors.xsd to match the documentation In Progress

Task # 4190: Update architecture docs to import dataoneErrors.xsd New

Task # 4191: Update python implementations of DataONE exceptions Closed

Task # 4192: Notify MN implementations of the discrepancy in exception definition In Progress

Related issues:

Related to Infrastructure - Bug #7967: The CN is not following the xml schema... In Progress 2017-01-14

History

#1 - 2013-12-03 15:17 - Dave Vieglais

- Status changed from New to In Progress

#2 - 2014-01-06 18:47 - Dave Vieglais

- Target version changed from 2013.49-Block.6.3 to 2014.2-Block.1.1

- Due date changed from 2013-12-14 to 2014-01-18

#3 - 2014-03-14 21:00 - Chris Jones

- Target version changed from 2014.2-Block.1.1 to 2014.14-Block.2.3

- Due date changed from 2014-01-18 to 2014-04-12

#4 - 2014-09-24 18:28 - Dave Vieglais

- Due date changed from 2014-04-12 to 2014-09-24

- Target version changed from 2014.14-Block.2.3 to Maintenance Backlog

#5 - 2017-01-14 00:49 - Rob Nahf

- Subject changed from Exception definition and implementation requires clarification to dataone Exception definition and implementation requires

clarification
- Target version changed from Maintenance Backlog to CCI-2.4.0

#6 - 2017-01-14 01:13 - Rob Nahf

- Related to Bug #7967: The CN is not following the xml schema definition when creating dataone exceptions added

#7 - 2017-01-23 21:36 - Rob Nahf

I think because the embedded schema file in the documentation (working link: 

http://jenkins-1.dataone.org/documentation/unstable/API-Documentation-development/apis/Exceptions) used the field 'identifier' instead of 'pid' which

is used in the html table to name the field, (yet had the new 'nodeId' field, too) the schema that became the 1.1.0 error schema inadvertently changed

the 'pid' field to 'identifier', breaking backwards compatibility.

the 'pid' field is optional, and only used with error responses to cn.resolve, and mn.synchronizationFailed calls.

Metacat's MNodeService.synchronizationFailed implementation does check the pid field.  If null, a ServiceFailure is returned to the caller.  As far as I

could tell, Metacat does not call cn.resolve and attempt to extract the value of the 'pid' field.

Because cn.resolves handles SIDs as of v2, maybe the field 'identifier' is most appropriate name for that field, moving forward.  (Or synchronization

can populate the 'pid' field, and the 'identifier' field is populated by cn.resolve(), and both fields are defined...)

#8 - 2018-01-17 20:05 - Dave Vieglais

- Sprint set to CCI-2.3.8
